#include <STDLIB.H>
#include <STDIO.H>
#include <DOS.H>
#include <CONIO.H>

#define LEVELLENGTH 2048

int   FBlink      =  0;
int   FDebug      =  0;
int   FCharSet    =  1;
int   FShowHidden = -1;
int   FLevelNumber;
int   FLevelTotal;
FILE* FFile;


void beep(void) {
  //Plays a beep sound through the PC speaker.
  //Pre:  True.
  //Post: True.

  sound(440);
  delay(200);
  nosound();
}


void setScreenMode(void) {
  //Set 80x25 16 color text mode without cursor.
  //Pre:  True
  //Post: The screen is in 80x25 16 color text mode without cursor,
  //      The screen is cleared.

  //set 640x200 2 color graphics mode
  //to make sure that in Windows the program runs full screen
  asm {
    mov ax, 0x0006;
    int 0x10;
  }

  //set 80x25 16 color text mode
  asm {
    mov ax, 3;
    int 0x10;
  }

  //remove cursor
  asm {
    mov ah,  1;
    mov ch, 32;
    int 0x10;
  }
}


void drawCharacterUsingCharSet1(int AX, int AY, unsigned char ACharacter) {
  //Draw character ACharacter at position (AX, AY).
  //Pre:  Screen is in 80x25 16 color text mode,
  //      0 <= AX < 79, 0 <= AY < 25
  //Post: Character ACharacter is drawn at position (AX, AY),
  //      The rest of the screen is unchanged.

  unsigned char c; //character
  unsigned char k; //color (kleur)

  switch (ACharacter) {
    case ' ': c =  32; k =  0;          	   break; //nothing
    case 'P': c =   1; k = 14 + 4 * 16; 	   break; //player
    case 'W': c = 244; k = 15;          	   break; //whip
    case '+': c =   4; k = 13;          	   break; //gem
    case 'T': c =  24; k = 13;          	   break; //teleporter
    case '.': c = 249; k =  7;          	   break; //teleport trap
    case 'C': c =  15; k = 14 + 4 * 16; 	   break; //chest
    case '*': c = '*'; k = 15;          	   break; //points
    case 'I': c =   9; k =  2;          	   break; //invisibility ring
    case '1': c = 142; k = 12;          	   break; //enemy 1
    case '2': c = 153; k = 10;          	   break; //enemy 2
    case '3': c = 234; k =  9;          	   break; //enemy 3
    case '#': c = 219; k =  6;                     break; //wall
    case 'X': c = 178; k =  6;                     break; //breakable wall
    case 'K': c = 140; k = 12;                     break; //key
    case 'L': c = 240; k =  0 + 7 * 16 + FBlink;   break; //exit
    case 'S': c = 232; k = 11;                     break; //slow time spell
    case 'U': c = 239; k = 15;                     break; //secret tunnel
    case 'B': c = 157; k = 15;                     break; //bomb
    case 'V': c = 178; k = 12 + 4 * 16;            break; //lava
    case '=': c = 176; k =  7;                     break; //bottomless pit
    case 'D': c = 236; k =  3 + 5 * 16;            break; //door
    case '`': c = 236; k = (FShowHidden ? 3 + 5 * 16 : 0); break; //hidden door
    case 'A': c = 231; k = 15 + 1 * 16;            break; //amulet
    case '/': c = 176; k =  6 + 2 * 16;            break; //forrest 1
    case '\\': c = 177; k = 6 + 2 * 16;            break; //forrest 2
    case 'F': c = 233; k = 11;                     break; //speed time spell
    case 'R': c = 176; k =  9 + 1 * 16 + FBlink;   break; //water
    case 'Q': c =   2; k =  9 + 4 * 16;            break; //increase whip power
    case ':': c = 219; k = (FShowHidden ? 6 : 0);  break; //hidden wall
    case ';': c = 178; k = (FShowHidden ? 6 : 0);  break; //hidden destructable wall
    case 'a': c = 'A'; k = 13 + 6 * 16;            break; //A
    case 'b': c = 'B'; k = 13 + 6 * 16;            break; //B
    case 'c': c = 'C'; k = 13 + 6 * 16;            break; //C
    case 'd': c = 'D'; k = 13 + 6 * 16;            break; //D
    case 'e': c = 'E'; k = 13 + 6 * 16;            break; //E
    case 'f': c = 'F'; k = 13 + 6 * 16;            break; //F
    case 'g': c = 'G'; k = 13 + 6 * 16;            break; //G
    case 'h': c = 'H'; k = 13 + 6 * 16;            break; //H
    case 'i': c = 'I'; k = 13 + 6 * 16;            break; //I
    case 'j': c = 'J'; k = 13 + 6 * 16;            break; //J
    case 'k': c = 'K'; k = 13 + 6 * 16;            break; //K
    case 'l': c = 'L'; k = 13 + 6 * 16;            break; //L
    case 'm': c = 'M'; k = 13 + 6 * 16;            break; //M
    case 'n': c = 'N'; k = 13 + 6 * 16;            break; //N
    case 'o': c = 'O'; k = 13 + 6 * 16;            break; //O
    case 'p': c = 'P'; k = 13 + 6 * 16;            break; //P
    case 'q': c = 'Q'; k = 13 + 6 * 16;            break; //Q
    case 'r': c = 'R'; k = 13 + 6 * 16;            break; //R
    case 's': c = 'S'; k = 13 + 6 * 16;            break; //S
    case 't': c = 'T'; k = 13 + 6 * 16;            break; //T
    case 'u': c = 'U'; k = 13 + 6 * 16;            break; //U
    case 'v': c = 'V'; k = 13 + 6 * 16;            break; //V
    case 'w': c = 'W'; k = 13 + 6 * 16;            break; //W
    case 'x': c = 'X'; k = 13 + 6 * 16;            break; //X
    case 'y': c = 'Y'; k = 13 + 6 * 16;            break; //Y
    case 'z': c = 'Z'; k = 13 + 6 * 16;            break; //Z
    case '!': c = '!'; k = 13 + 6 * 16;            break; //!
    case 'Z': c = 159; k = 11;                     break; //freeze time spell
    case 'E': c = 'E'; k = (FShowHidden ? 15 : 0); break; //earthquake trap

    //Show unknown invisible tiles
    case '@': c = '@'; k = (FDebug ? 15 + 7 * 16 : 0); break; //creatures can't walk trough this tile
    case '-': c = '-'; k = (FDebug ? 15 + 7 * 16 : 0); break; //creatures can't walk trough this tile

    case 178: c = 178; k = 44; break; //border

    default:  c = ACharacter; k = 33 + 128; beep(); break; //UNKNOWN TILE, SOMETHING'S WRONG
  }

  //draw character with right color
  pokeb(0xB800, AY * 160 + AX + AX    , c);
  pokeb(0xB800, AY * 160 + AX + AX + 1, k);

}


void drawCharacterUsingCharSet2(int AX, int AY, unsigned char ACharacter) {
  //Draw character ACharacter at position (AX, AY).
  //Pre:  Screen is in 80x25 16 color text mode,
  //      0 <= AX < 79, 0 <= AY < 25
  //Post: Character ACharacter is drawn at position (AX, AY),
  //      The rest of the screen is unchanged.

  unsigned char c; //character
  unsigned char k; //color (kleur)

  switch (ACharacter) {
    case ' ': c =  32; k =  0;               	   break; //nothing
    case 'P': c =   1; k = 14 + 4 * 16; 	   break; //player
    case 'W': c = 244; k = 15;          	   break; //whip
    case '+': c =   4; k = 13;          	   break; //gem
    case 'T': c =  24; k = 13;          	   break; //teleporter
    case '.': c = 249; k =  7;          	   break; //teleport trap
    case 'C': c =  15; k = 14 + 4 * 16; 	   break; //chest
    case '*': c = '*'; k = 15;          	   break; //points
    case 'I': c =   9; k =  2;          	   break; //invisibility ring
    case '1': c = 142; k = 12;          	   break; //enemy 1
    case '2': c = 153; k = 10;          	   break; //enemy 2
    case '3': c = 234; k =  9;          	   break; //enemy 3
    case '#': c = 219; k =  6;                     break; //wall
    case 'X': c = 178; k =  6;                     break; //breakable wall
    case 'K': c = 140; k = 12;                     break; //key
    case 'L': c = 240; k =  0 + 7 * 16 + FBlink;   break; //exit
    case 'S': c = 232; k = 11;                     break; //slow time spell
    case 'U': c = 239; k = 15;                     break; //secret tunnel
    case 'B': c = 157; k = 15;                     break; //bomb
    case 'V': c = 178; k = 12 + 4 * 16 + FBlink;   break; //lava
    case '=': c = 176; k =  7;                     break; //bottomless pit
    case 'D': c = 236; k =  3 + 5 * 16;            break; //door
    case '`': c = 236; k = (FShowHidden ? 3 + 5 * 16 : 0); break; //hidden door
    case 'A': c =  12; k = 15 + 2 * 16;            break; //amulet
    case '/': c = 176; k =  6 + 2 * 16;            break; //forrest 1
    case '\\': c = 177; k = 6 + 2 * 16;            break; //forrest 2
    case 'F': c = 233; k = 11;                     break; //speed time spell
    case 'R': c = 176; k =  9 + 1 * 16 + FBlink;   break; //water
    case 'Q': c =   2; k =  9 + 4 * 16;            break; //increase whip power
    case ':': c = 219; k = (FShowHidden ? 6 : 0);  break; //hidden wall
    case ';': c = 178; k = (FShowHidden ? 6 : 0);  break; //hidden destructable wall
    case 'a': c = 'a'; k = 13 + 6 * 16;            break; //A
    case 'b': c = 'b'; k = 13 + 6 * 16;            break; //B
    case 'c': c = 'c'; k = 13 + 6 * 16;            break; //C
    case 'd': c = 'd'; k = 13 + 6 * 16;            break; //D
    case 'e': c = 'e'; k = 13 + 6 * 16;            break; //E
    case 'f': c = 'f'; k = 13 + 6 * 16;            break; //F
    case 'g': c = 'g'; k = 13 + 6 * 16;            break; //G
    case 'h': c = 'h'; k = 13 + 6 * 16;            break; //H
    case 'i': c = 'i'; k = 13 + 6 * 16;            break; //I
    case 'j': c = 'j'; k = 13 + 6 * 16;            break; //J
    case 'k': c = 'k'; k = 13 + 6 * 16;            break; //K
    case 'l': c = 'l'; k = 13 + 6 * 16;            break; //L
    case 'm': c = 'm'; k = 13 + 6 * 16;            break; //M
    case 'n': c = 'n'; k = 13 + 6 * 16;            break; //N
    case 'o': c = 'o'; k = 13 + 6 * 16;            break; //O
    case 'p': c = 'p'; k = 13 + 6 * 16;            break; //P
    case 'q': c = 'q'; k = 13 + 6 * 16;            break; //Q
    case 'r': c = 'r'; k = 13 + 6 * 16;            break; //R
    case 's': c = 's'; k = 13 + 6 * 16;            break; //S
    case 't': c = 't'; k = 13 + 6 * 16;            break; //T
    case 'u': c = 'u'; k = 13 + 6 * 16;            break; //U
    case 'v': c = 'v'; k = 13 + 6 * 16;            break; //V
    case 'w': c = 'w'; k = 13 + 6 * 16;            break; //W
    case 'x': c = 'x'; k = 13 + 6 * 16;            break; //X
    case 'y': c = 'y'; k = 13 + 6 * 16;            break; //Y
    case 'z': c = 'z'; k = 13 + 6 * 16;            break; //Z
    case '!': c = '!'; k = 13 + 6 * 16;            break; //!
    case 'Z': c = 159; k = 11;                     break; //freeze time spell
    case 'E': c = 'E'; k = (FShowHidden ? 15 : 0); break; //earthquake trap

    //Show unknown invisible tiles
    case '@': c = '@'; k = (FDebug ? 15 + 7 * 16 : 0); break; //creatures can't walk trough this tile
    case '-': c = '-'; k = (FDebug ? 15 + 7 * 16 : 0); break; //creatures can't walk trough this tile

    case 178: c = 178; k = 44; break; //border

    default:  c = ACharacter; k = 33 + 128; beep(); break; //UNKNOWN TILE, SOMETHING'S WRONG
  }

  //draw character with right color
  pokeb(0xB800, AY * 160 + AX + AX    , c);
  pokeb(0xB800, AY * 160 + AX + AX + 1, k);

}


void drawCharacter (int AX, int AY, unsigned char ACharacter) {
  //Draw character ACharacter at position (AX, AY) using a specific
  //character set.
  //Pre:  1 <= FCharSet <= 2.
  //Post: Character ACharacter is drawn at position (AX, AY),
  //      The rest of the screen is unchanged.

  switch (FCharSet) {
    case 1: drawCharacterUsingCharSet1(AX, AY, ACharacter); break;
    case 2: drawCharacterUsingCharSet2(AX, AY, ACharacter); break;

    default: beep(); printf("FCharSet switch bug!\n"); exit(EXIT_FAILURE);
  }
}


void drawBorder(void) {
  // Draw border.
  // Pre:  Screen is in 80x25 16 color text mode.
  // Post: Border is drawn, the rest of the screen is unchanged.

  int z;

  //upper and bottom border
  for (z = 0; z < 66; z++) {
    drawCharacter(z,  0, 178); //upper border
    drawCharacter(z, 24, 178); //bottom border
  }

  //left and right border
  for (z = 1; z < 24; z++) {
    drawCharacter(0,  z, 178); //left border
    drawCharacter(65, z, 178); //right border
  }
}


void drawRightWindow(void) {
  //Draw window on the right-hand side of the screen
  //Pre:  Screen is in 80x25 16 color mode.
  //Post: Menu is drawn, rest of the screen is unchanged.

  int x;
  int y;

  //Blue background.
  for (y = 0; y < 25; y++) {
    for (x = 66; x < 80; x++) {
      pokeb(0xB800, y * 160 + x + x    ,  0);
      pokeb(0xB800, y * 160 + x + x + 1, 16);
    }
  }

  textattr(14 + 1 * 16);
  gotoxy(70, 1); cprintf("KROZLEV");
  gotoxy(68, 2); cprintf("Frenkel 2008");

  //Level x / y
  gotoxy(71,  4);
  textattr(14 + 1 * 16); cprintf("Level");
  gotoxy(70,  5);
  textattr( 4 + 7 * 16); cprintf("%2d / %2d", FLevelNumber+1, FLevelTotal);

  //Blinking ON/OFF
  gotoxy(70, 7);
  textattr(14 + 1 * 16); cprintf("Blinking");
  gotoxy(70, 8);
  textattr( 4 + 7 * 16); cprintf((FBlink ? "  ON   ": "  OFF  "));

  //Show hidden ON/OFF
  gotoxy(70, 10);
  textattr(14 + 1 * 16); cprintf("Hiding");
  gotoxy(70, 11);
  textattr( 4 + 7 * 16); cprintf((FShowHidden ? "  OFF  ": "  ON   "));

  //X tiles ON/OFF
  gotoxy(70, 13);
  textattr(14 + 1 * 16); cprintf("X tiles");
  gotoxy(70, 14);
  textattr( 4 + 7 * 16); cprintf((FDebug ? "  ON   ": "  OFF  "));

  //Char set
  gotoxy(70, 16);
  textattr(14 + 1 * 16); cprintf("Char set");
  gotoxy(70, 17);
  textattr( 4 + 7 * 16); cprintf("   %d   ", FCharSet);


  //OPTIONS
  gotoxy(70, 19);
  textattr(11 + 4 * 16); cprintf("OPTIONS");

  //Level <-, ->
  gotoxy(68, 20);
  textattr( 7+1*16); cprintf("Level  ,");
  pokeb(0xB800, 19 * 160 + 73 * 2    ,          27);
  pokeb(0xB800, 19 * 160 + 73 * 2 + 1, 15 + 1 * 16);
  pokeb(0xB800, 19 * 160 + 76 * 2    ,          26);
  pokeb(0xB800, 19 * 160 + 76 * 2 + 1, 15 + 1 * 16);

  //Blink
  gotoxy(68, 21);
  textattr(15 + 1 * 16); cprintf("B");
  textattr( 7 + 1 * 16); cprintf("link");

  //Show hidden
  gotoxy(68, 22);
  textattr( 7 + 1 * 16); cprintf("Show ");
  textattr(15 + 1 * 16); cprintf("h");
  textattr( 7 + 1 * 16); cprintf("idden");

  //X tiles
  gotoxy(68, 23);
  textattr(15 + 1 * 16); cprintf("X");
  textattr( 7 + 1 * 16); cprintf(" tiles");

  //Char set 1-2
  gotoxy(68, 24);
  textattr( 7 + 1 * 16); cprintf("Char set ");
  textattr(15 + 1 * 16); cprintf("1");
  textattr( 7 + 1 * 16); cprintf("-");
  textattr(15 + 1 * 16); cprintf("2");

  //Quit
  gotoxy(68, 25);
  textattr(15 + 1 * 16); cprintf("Q");
  textattr( 7 + 1 * 16); cprintf("uit");
}


void waitForKeyPress(void) {
  //Wait for the user to press a key.
  //Pre:  True
  //Post: True

  printf("Press any key to continue.\n\n");

  asm {
    xor ax, ax;
    int 0x16;
  }
}


void drawLevel(int ALevelNumber) {
  // Draw level ALevelNumber.
  // Pre:  Screen is in 80x25 16 color text mode,
  //       0 <= ALevel < FLevelTotal.
  // Post: Level ALevelNumber is drawn on screen.

  int   offset;
  int   x;
  int   y;
  char* level;

  level = (char*) malloc(LEVELLENGTH);
  if (level == NULL) {
    printf("Not enough memory available!\n");
    waitForKeyPress();
    exit(EXIT_FAILURE);
  }

  fseek(FFile, 1L * ALevelNumber * LEVELLENGTH, SEEK_SET);
  fread(level, sizeof(char), LEVELLENGTH, FFile);

  offset = 23;
  for (y = 1; y < 24; y++) {
    for (x = 1; x < 65; x++) {
      drawCharacter(x, y, level[offset]);
      offset++;
    }
    offset = offset + 14;
  }

  free(level);
}


long getFileSize(FILE* AFile) {
  //Returns the size of file AFile.
  //Pre: AFile != NULL
  //Ret: size of file AFile.

  long curpos;
  long length;

  curpos = ftell(AFile);
  fseek(AFile, 0L, SEEK_END);
  length = ftell(AFile);
  fseek(AFile, curpos, SEEK_SET);

  return length;
}


int isValidKrozLevelFile(FILE* AFile) {
  //Returns whether AFile is a valid Kroz level file.
  //Pre: AFile != NULL
  //Ret: True,  if AFile is     a valid Kroz level file.
  //     False, if AFile is not a valid Kroz level file.

  return ((getFileSize(AFile) % LEVELLENGTH) == 0);
}


int quitQuestion(void) {
  //Ask user whether she really want to quit or not
  //Pre: Screen is in 80x25 16 color text mode
  //Ret: -1, if user wants to quit
  //      0, if user does not want to quit

  int c;

  while (!kbhit()) {
    gotoxy(24, 25);
    textattr((rand() % 15) + 1);
    cprintf("Are you sure (Y/N)?");
  }

  c = getch();
  if (!c) {
    getch();
  }

  if ((c == 'Y') || (c == 'y')) {
    return -1;
  }
  else {
    //remove question
    drawBorder();
    return 0;
  }
}


int main(int argc, char* argv[]) {
  //Draws all the levels in a Kroz level file on the screen, one at a time.
  //Pre: True
  //Ret:  0, if successful
  //     -1, if an error occurred

  int c;
  int e; //extended
  int quit;

  printf("Kroz level viewer by Frenkel, 09-Jul-2008.\n");
  waitForKeyPress();

  if (argc < 2) {
    printf("Usage: KROZLEV $FILENAME$, where $FILENAME$ is the name of the level file.\n");
    waitForKeyPress();
    exit(EXIT_FAILURE);
  }

  FFile = fopen(argv[1], "rb");
  if (FFile == NULL) {
    printf("Can't find %s!\n", argv[1]);
    waitForKeyPress();
    exit(EXIT_FAILURE);
  }

  if (!isValidKrozLevelFile(FFile)) {
    printf("%s is not a valid Kroz level file!\n", argv[1]);
    waitForKeyPress();
    exit(EXIT_FAILURE);
  }


  setScreenMode();

  FLevelNumber = 0;
  FLevelTotal  = getFileSize(FFile) / LEVELLENGTH;

  drawBorder();
  drawLevel(0);
  drawRightWindow();

  quit = 0;
  while (!quit) {
    c = getch();
    if (!c) {
      e = getch();
    }

    if (!c && (e == 'M')) {
      FLevelNumber++;
      if (FLevelTotal <= FLevelNumber) {
	FLevelNumber = (FLevelTotal) - 1;
	beep();
      }
    }
    else if (!c && (e == 'K')) {
      FLevelNumber--;
      if (FLevelNumber < 0) {
	FLevelNumber = 0;
	beep();
      }
    }
    else if ((c == 'b') || (c == 'B')) {
      FBlink = 128 - FBlink;
    }
    else if ((c == 'x') || (c == 'X')) {
      FDebug = !FDebug;
    }
    else if ((c == 'h') || (c == 'H')) {
      FShowHidden = !FShowHidden;
    }
    else if (c == '1') {
      FCharSet = 1;
    }
    else if (c == '2') {
      FCharSet = 2;
    }
    else if ((c == 27) || (c == 'q') || (c == 'Q')) {
      quit = quitQuestion();
    }

    drawLevel(FLevelNumber);
    drawRightWindow();
  }

  //set 80x25 16 color text mode
  //to clear screen and to make cursor visible again
  asm {
    mov ax, 3;
    int 0x10;
  }

  printf("Kroz level viewer by Frenkel, 09-Jul-2008.\n");
  waitForKeyPress();

  return 0;
}